package CFG;

import java.util.Set;
import java.util.TreeSet;

import parser.Node;

public class Edge implements Comparable<Edge>{
	//all the edges in the CFG
	public static Set<Edge> allEdges = new TreeSet<>();
	
	Node u;
	Node v;
	String type;
	Edge(Node a, Node b, String t) throws Exception
	{
		if(a==null)
			throw new Exception("Cannot add an edge going out of null. v="+b);
		if(!a.type.equals("stmt") || (b!=null && !b.type.equals("stmt")))
			throw new Exception("Cannot add edges between non-stmt nodes."+a+"\n"+b);
		u=a;
		v=b;
		type=t;
		allEdges.add(this);
	}
	
	public String toString()
	{
		String ans = u.statementId+" -> ";
		if(v!=null)
			ans+=v.statementId;
		else
			ans+="end";
		
		ans+=" ("+type+")";
		return ans;
	}

	@Override
	public int compareTo(Edge other) {
		int uid = -1, vid=-1, otheruid=-1, othervid=-1;
		if(u!=null)
			uid=u.id;
		if(v!=null)
			vid=v.id;
		if(other.u!=null)
			otheruid=other.u.id;
		if(other.v!=null)
			othervid=other.v.id;
		if(uid<otheruid)
			return -1;
		else if(uid==otheruid && vid<othervid)
			return -1;
		else if(uid==otheruid && vid==othervid)
			return 0;
		else
			return 1;
	}
}
